// OutLookRichEdit.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "OutLookRichEdit.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutLookRichEdit

/*---------------------------------------------------------------
Function name     : COutLookRichEdit::COutLookRichEdit
Description	      : 
Return type		  : 
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
COutLookRichEdit::COutLookRichEdit()
{	
	m_hLinkCursor = AfxGetApp()->LoadCursor (IDC_LINK);	//Should have the hand cursor in resource	
	//If this lines shows build-error then
	//please import the hand cursor, and rename it with IDC_LINK
}



/*---------------------------------------------------------------
Function name     : COutLookRichEdit::~COutLookRichEdit
Description	      : 
Return type		  : 
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
COutLookRichEdit::~COutLookRichEdit()
{
	if(!m_lsLinks.IsEmpty ())
	{
		m_lsLinks.RemoveAll();
	}
}


BEGIN_MESSAGE_MAP(COutLookRichEdit, CRichEditCtrl)
	//{{AFX_MSG_MAP(COutLookRichEdit)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutLookRichEdit message handlers

/*---------------------------------------------------------------
Function name     : COutLookRichEdit::SetRTF
Description	      : 
Return type		  : void 
Argument          : CString sRTF
Author            : Jeremy Iverson
Type              : 
Created on        : March 18, 1999 
Contact (MailID)  : jeremy@devpointsoftware.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::SetRTF(CString sRTF)
{
	// Put the RTF string sRTF into the rich edit control.

	// Read the text in
	EDITSTREAM es;
	es.dwError = 0;
	es.pfnCallback = CBStreamIn;
	es.dwCookie = (DWORD) &sRTF;
	StreamIn(SF_RTF, es);	// Do it.
	
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::CBStreamIn
Description	      : Callback function to stream an RTF string into the rich edit control.
Return type		  : DWORD CALLBACK 
Argument          : DWORD dwCookie
Argument          : LPBYTE pbBuff
Argument          : LONG cb
Argument          : LONG *pcb
Author            : Zafir Anjum
Type              : 
Created on        : 
Contact (MailID)  : 
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
DWORD CALLBACK COutLookRichEdit::CBStreamIn(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	// We insert the rich text here.
/*	
	This function taken from CodeGuru.com
	http://www.codeguru.com/richedit/rtf_string_streamin.shtml
	Zafir Anjum
*/
	CString *pstr = (CString *) dwCookie;

	if (pstr->GetLength() < cb)
	{
		*pcb = pstr->GetLength();
		memcpy(pbBuff, (LPCSTR) *pstr, *pcb);
		pstr->Empty();
	}
	else
	{
		*pcb = cb;
		memcpy(pbBuff, (LPCSTR) *pstr, *pcb);
		*pstr = pstr->Right(pstr->GetLength() - cb);
	}
	return 0;
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::CBStreamOut
Description	      : Callback function to stream the RTF string out of the rich edit control.
Return type		  : DWORD CALLBACK 
Argument          : DWORD dwCookie
Argument          : LPBYTE pbBuff
Argument          : LONG cb
Argument          : LONG *pcb
Author            : Zafir Anjum
Type              : 
Created on        : 
Contact (MailID)  : 
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
DWORD CALLBACK COutLookRichEdit::CBStreamOut(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	// Address of our string var is in psEntry
	CString *psEntry = (CString*) dwCookie;
	

	CString tmpEntry = _T("");
	tmpEntry = (CString) pbBuff;

	// And write it!!!
	*psEntry += tmpEntry.Left(cb);

	return 0;
}

/*---------------------------------------------------------------
Function name     : COutLookRichEdit::GetCharFormat
Description	      : 
Return type		  : CHARFORMAT 
Argument          : DWORD dwMask
Author            : Jeremy Iverson
Type              : 
Created on        : March 18, 1999 
Contact (MailID)  : jeremy@devpointsoftware.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
CHARFORMAT COutLookRichEdit::GetCharFormat(DWORD dwMask)
{
	CHARFORMAT cf;
	cf.cbSize = sizeof(CHARFORMAT);

	cf.dwMask = dwMask;

	GetSelectionCharFormat(cf);

	return cf;
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::SetCharStyle
Description	      : 
Return type		  : void 
Argument          : int MASK
Argument          : int STYLE
Argument          : int nStart
Argument          : int nEnd
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::SetCharStyle(int MASK, int STYLE, int nStart, int nEnd)
{
	CHARFORMAT cf;
	cf.cbSize = sizeof(CHARFORMAT);
	//cf.dwMask = MASK;
	
	GetSelectionCharFormat(cf);
	
	if (cf.dwMask & MASK)	// selection is all the same
	{
		cf.dwEffects ^= STYLE; 
	}
	else
	{
		cf.dwEffects |= STYLE;
	}
	
	cf.dwMask = MASK;

	SetSelectionCharFormat(cf);

}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::GetParagraphFormat
Description	      : 
Return type		  : PARAFORMAT 
Author            : Jeremy Iverson
Type              : 
Created on        : March 18, 1999 
Contact (MailID)  : jeremy@devpointsoftware.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
PARAFORMAT COutLookRichEdit::GetParagraphFormat()
{
	PARAFORMAT pf;
	pf.cbSize = sizeof(PARAFORMAT);

	pf.dwMask = PFM_ALIGNMENT | PFM_NUMBERING;    	

	GetParaFormat(pf);

	return pf;
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::CBEnumFonts
Description	      : 
Return type		  : BOOL CALLBACK 
Argument          : LPLOGFONT lplf
Argument          : LPTEXTMETRIC lptm
Argument          : DWORD dwType
Argument          : LPARAM lpData
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
BOOL CALLBACK COutLookRichEdit::CBEnumFonts(LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData)
{
	if (dwType == TRUETYPE_FONTTYPE) 
	{
		((CStringArray *) lpData)->Add( lplf->lfFaceName );
	}

	return true;
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::OnMouseMove
Description	      : 
Return type		  : void 
Argument          : UINT nFlags
Argument          : CPoint point
Author            : Madhu B Nair
Type              : Wizard Generated/Protected
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::OnMouseMove(UINT nFlags, CPoint point) 
{	
	HYPERLINKINFO linkInfo;
	if(IsPointInsideALink(point,linkInfo))
	{
		if(NULL != m_hLinkCursor){
			SetCursor(m_hLinkCursor);}

	}
	CRichEditCtrl::OnMouseMove(nFlags, point);
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::OnLButtonDown
Description	      : 
Return type		  : void 
Argument          : UINT nFlags
Argument          : CPoint point
Author            : Madhu B Nair
Type              : Wizard Generated/Protected
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::OnLButtonDown(UINT nFlags, CPoint point) 
{
    
	CRichEditCtrl::OnLButtonDown(nFlags, point);
	HYPERLINKINFO linkInfo;
	
	if(IsPointInsideALink(point,linkInfo))
	{
		NMHDR header;
		header.hwndFrom = this->m_hWnd ;
		header.idFrom   = GetDlgCtrlID ();
		header.code     = linkInfo.unLinkDlgID;
		GetParent()->SendMessage(WM_NOTIFY,(WPARAM) header.idFrom,(LPARAM)&header);
	}	
}

void COutLookRichEdit::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
	SetBoundariesToLinks ();
	CRichEditCtrl::OnVScroll (nSBCode,nPos,pScrollBar);

}
void COutLookRichEdit::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
	SetBoundariesToLinks ();
	CRichEditCtrl::OnHScroll (nSBCode,nPos,pScrollBar);

}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::AddLink
Description	      : 
Return type		  : BOOL 
Argument          : CString csLinkText
Argument          : CRect rectLink
Argument          : UINT unLinkToDlgID
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
BOOL COutLookRichEdit::AddLink(CString csLinkText, CRect rectLink, UINT unLinkToDlgID)
{
	BOOL bRetVal = TRUE;
	do
	{
		try
		{
			if(csLinkText.IsEmpty ())
			{
				bRetVal = FALSE;
				break;
			}
			if(NULL == unLinkToDlgID )
			{
				bRetVal = FALSE;
				break;
			}

			HYPERLINKINFO linkInfo;

			linkInfo.csLinkText	   = csLinkText;
			linkInfo.rectDimension = rectLink;
			linkInfo.unLinkDlgID   = unLinkToDlgID;
			//Add to list
			//Add to head if list is empty ; otherwise add to tail
			if(m_lsLinks.IsEmpty ())
			{
				m_lsLinks.AddHead(linkInfo);
			}
			else
			{
				m_lsLinks.AddTail (linkInfo);
			}			
		}
		catch(...)
		{
			bRetVal = FALSE;
		}
	}while(0);

	return bRetVal;
}

/*---------------------------------------------------------------
Function name     : COutLookRichEdit::IsPointInsideALink
Description	      : 
Return type		  : BOOL 
Argument          : POINT pt
Argument          : HYPERLINKINFO &linkInfo
Argument          : const char *csText
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
BOOL COutLookRichEdit::IsPointInsideALink(POINT pt,HYPERLINKINFO &linkInfo,const char *csText)
{
	POSITION posInList = NULL;
	BOOL bReturn	   = FALSE;
	do
	{
		try
		{
			if(m_lsLinks.IsEmpty ())
			{
				posInList = NULL;				
				break;
			}
			
			posInList = m_lsLinks.GetHeadPosition ();
			do
			{
				linkInfo = m_lsLinks.GetAt (posInList);
				if(linkInfo.rectDimension.IsRectEmpty ()) {break;};
				if(linkInfo.rectDimension.PtInRect (pt))
				{	
					bReturn = TRUE;
					break;
				}
				m_lsLinks.GetNext (posInList);
			}while(NULL != posInList);
			
		}
		catch(...)
		{
			bReturn = FALSE;
		}
	}while(0);
	
	return bReturn;
}

/*---------------------------------------------------------------
Function name     : COutLookRichEdit::SetRawHyperText
Description	      : Key funtion of this class !!
					Follow this markup for adding links to rtf.
					"some_text <%$the_link_text$#link_dlg_id#%> some_text "
					Use any rtf symbols along with 'some_text' part.
					e.g \\par for new line.
Return type		  : void 
Argument          : const char *csRawText
Author            : Madhu B Nair
Type              : 
Created on        : 6/10/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::SetRawHyperText(const char *csRawText)
{
	m_csRAWText = csRawText;
	do
	{
		try
		{
			if(m_csRAWText.IsEmpty ()){break;}
			//Refresh the links information
			if(!m_lsLinks.IsEmpty ()){m_lsLinks.RemoveAll();}
			CString csTemp,csTempRaw,csTempRawOld,csTempMisc;
			csTempRawOld = RTF_SKELTON;//Have the rtf skelton with a <@RAW@> to replace our text
			csTempRaw    = m_csRAWText;
			int nStart=0,nEnd=0;
			do
			{
			//Find the link mark up ...
			nStart = csTempRaw.Find (_T("<%"),nStart);
			nEnd   = csTempRaw.Find (_T("%>"),nStart);
			//Get the text in between <% and %> store it for final replace
			csTempMisc = csTempRaw.Mid (nStart,(nEnd - nStart) + 2);
			//We don't need these markups for further steps so discard it.
			csTemp     = csTempMisc;
			csTemp.Remove ('<');csTemp.Remove ('%');csTemp.Remove ('>');
			//Now pass the mark-up raw text to parse and add the link information
			//to m_lsLinks list. The fuction ParseAndAddToList will return the
			//rtf formated text to replace csTempMisc in csTempRaw
			ParseAndAddToList(csTemp);
			csTempRaw.Replace (csTempMisc,csTemp);
			//Search again for another occurance of mark-up
			nStart = csTempRaw.Find (_T("<%"),nStart);	

			}while(nStart > 0);

			//Now replace the skelton with formatted link text
			csTempRawOld.Replace (_T("<@RAW@>"),csTempRaw);
			SetRTF(csTempRawOld);
			//The stage is ready for the show.. before proceeding
			//we have to store the boudaries to links
			SetBoundariesToLinks ();
		}
		catch(...)
		{
			break;
		}
		
	}while(0);
}

/*---------------------------------------------------------------
Function name     : COutLookRichEdit::ParseAndAddToList
Description	      : 
Return type		  : void 
Argument          : CString &csTemp
Author            : Madhu B Nair
Type              : 
Created on        : 6/11/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::ParseAndAddToList(CString &csTemp)
{
	CString csLinkText(_T("")),csMisc(_T(""));
	UINT    unDlgID;
	int nStart=0,nEnd=0;
	do
	{
		try
		{
			nStart = csTemp.Find (_T("$"),nStart);
			nStart += 1;
			nEnd   = csTemp.Find (_T("$"),nStart);
			
			csLinkText = csTemp.Mid (nStart,(nEnd - nStart));
			nStart = nEnd;
			nStart = csTemp.Find (_T("#"),nStart);
			nStart += 1;
			nEnd   = csTemp.Find (_T("#"),nStart);
			unDlgID = atoi(csTemp.Mid (nStart,(nEnd - nStart)));
			if(!AddLink (csLinkText,NULL,unDlgID)) break;
			csMisc = RTF_LINK;
			csMisc.Replace (_T("<@UTEXT@>"),csLinkText);
			csTemp = csMisc;			
		}
		catch(...)
		{
			break;
		}
	}while(0);

}



/*---------------------------------------------------------------
Function name     : COutLookRichEdit::SetBoundariesToLinks
Description	      : 
Return type		  : void 
Author            : Madhu B Nair
Type              : 
Created on        : 6/11/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::SetBoundariesToLinks()
{
	CDC *pdc = GetDC();
	do{
		POSITION posInList;
		FINDTEXTEX ftext;
		int nMin = 0;

		HYPERLINKINFO linkInfo;
		try
		{
			if(m_lsLinks.IsEmpty ())
			{
				posInList = NULL;				
				break;
			}			
			posInList = m_lsLinks.GetHeadPosition ();
			do
			{
				linkInfo = m_lsLinks.GetAt (posInList);
				//Find the text dimensions height and width for 
				//current logfont, of given text
				CSize size =  pdc->GetTextExtent(linkInfo.csLinkText);
				//Find the given text range.
				ftext.lpstrText = new char [linkInfo.csLinkText.GetLength () + 1];
				strcpy(ftext.lpstrText,linkInfo.csLinkText);
				ftext.chrg.cpMin = nMin;
				ftext.chrg.cpMax = -1; //Search the text in full content
				if(-1 != FindText (FR_MATCHCASE|FR_WHOLEWORD,&ftext))
				{
					//If found store the first and last points of the string					
					CPoint oFirst,oLast;
					oFirst = GetCharPos (ftext.chrgText.cpMin);
					oLast  = GetCharPos (ftext.chrgText.cpMax);
					linkInfo.rectDimension.top    = oFirst.y;
					linkInfo.rectDimension.left   = oFirst.x;
					linkInfo.rectDimension.right  = (oFirst.x + size.cx);// - 10; //x + width
					linkInfo.rectDimension.bottom = (oFirst.y + size.cy); //y + height					
					nMin   = ftext.chrgText.cpMax;
					m_lsLinks.SetAt (posInList,linkInfo);
				}			
				delete [] ftext.lpstrText;
				m_lsLinks.GetNext (posInList);
			}while(NULL != posInList);
			
			
		}
		catch(...)
		{
			break;
		}
	}while(0);
	
	ReleaseDC(pdc);
}
/*---------------------------------------------------------------
Function name     : COutLookRichEdit::FindNthLink
Description	      : 
Return type		  : void 
Argument          : int nLinkNo
Argument          : CString &csLink
Author            : Madhu B Nair
Type              : 
Created on        : 6/13/02
Contact (MailID)  : madhu_na@hotmail.com
Modified by       : 
Modified on       : 
Contact (MailID)  : 
---------------------------------------------------------------*/
void COutLookRichEdit::FindNthLink(int nLinkNo,CString &csLink)
{
	int nStart,nEnd,nCount;
	nStart = nEnd = nCount = 0;
	do
	{
	nStart	   = m_csRAWText.Find ('$',nEnd);
	nStart += 1;
	nEnd	   = m_csRAWText.Find ('$',nStart);
	nEnd++;
	nCount++;
	}while(nCount == nLinkNo);
	nEnd--;
	csLink = "$" + m_csRAWText.Mid(nStart,nEnd - nStart) + "$";
	
}
void COutLookRichEdit::ReplaceNthLink(int nLinkNo,const CString csNewValue)
{	
	CString csOldValue(_T(""));
	FindNthLink (nLinkNo,csOldValue);
	CString csTemp2 = _T("$") + csNewValue + _T("$");	
	m_csRAWText.Replace (csOldValue,csTemp2);	
	SetRawHyperText (m_csRAWText);
}