#if !defined(AFX_OUTLOOKRICHEDIT_H__56086561_7C5A_11D6_B351_00C026A9CF82__INCLUDED_)
#define AFX_OUTLOOKRICHEDIT_H__56086561_7C5A_11D6_B351_00C026A9CF82__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OutLookRichEdit.h : header file
//
 

/////////////////////////////////////////////////////////////////////////////
// COutLookRichEdit window

#include <afxtempl.h>

#define RTF_SKELTON _T("{\\rtf1\\ansi\\deff0\\deftab720{\\fonttbl{\\f0\\fswiss MS Sans Serif;}{\\f1\\froman\\fcharset2 Symbol;}{\\f2\\froman Times New Roman;}{\\f3\\fswiss Arial;}}{\\colortbl\\red0\\green0\\blue0;\\red0\\green0\\blue255;}\\deflang1033\\pard\\plain\\f2\\fs20 <@RAW@>}");
#define RTF_LINK    _T(" \\plain\\f2\\fs20\\cf1\\ul <@UTEXT@>\\plain\\f2\\fs20 ");


/*------------------------------------------------------------------------
	Class			: COutLookRichEdit
	Author          : Madhu B Nair
	Created on      : 6/10/02
	Contact (MailID): madhu_na@hotmail.com	
--------------------------------------------------------------------------
	Type			:
	Description		:
	Revision History: 
------------------------------------------------------------------------*/
class COutLookRichEdit : public CRichEditCtrl
{
	// Construction
public:
	COutLookRichEdit();
	
	// Attributes
public:
	CStringArray m_saFontList;
private:
	typedef struct _HYPERLINKINFO
	{
		CRect   rectDimension;
		CString csLinkText;
		UINT    unLinkDlgID;
		inline operator = (struct _HYPERLINKINFO linkInfo){ rectDimension = linkInfo.rectDimension;csLinkText = linkInfo.csLinkText;unLinkDlgID = linkInfo.unLinkDlgID;}
	}HYPERLINKINFO,*LPHYPERLINKINFO;
	
	HCURSOR  m_hLinkCursor;
	CList <HYPERLINKINFO,HYPERLINKINFO&> m_lsLinks;
	
	// Operations
public:
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COutLookRichEdit)
	//}}AFX_VIRTUAL
	
	// Implementation
public:	
	void SetRawHyperText(const char* csRawText);	
	virtual ~COutLookRichEdit();
	
	// Generated message map functions
protected:
	CString m_csRAWText;
	BOOL IsPointInsideALink(POINT pt,HYPERLINKINFO &linkInfo,const char* csText="");
	//{{AFX_MSG(COutLookRichEdit)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()
private:
	BOOL AddLink(CString csLinkText, CRect rectLink, UINT unLinkToDlgID);	
	PARAFORMAT GetParagraphFormat();
	CHARFORMAT GetCharFormat(DWORD dwMask = CFM_COLOR | CFM_FACE | CFM_SIZE | CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE);	
	void SetRTF(CString sRTF);
	void ReplaceNthLink(int nLinkNo,const CString csNewValue);
	void FindNthLink(int nLinkNo,CString &csLink);
	void SetBoundariesToLinks();
	void ParseAndAddToList(CString& csTemp);
	void SetCharStyle(int MASK, int STYLE, int nStart, int nEnd);
	static DWORD CALLBACK CBStreamIn(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
	static DWORD CALLBACK CBStreamOut(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG* pcb);
	static BOOL CALLBACK CBEnumFonts(LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OUTLOOKRICHEDIT_H__56086561_7C5A_11D6_B351_00C026A9CF82__INCLUDED_)
